/*
 * Copyright (C) 2006 Jonathan McDowell <noodles@earth.li>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#define VERSION "0.0.1"

#include "delay.h"
#include "nand.h"
#include "types.h"
#include "uart.h"

void c_entry(void) {
	/* Just light email LED */
	*(volatile u8 *) 0x01000000 = 4;

	/* Init UART */
	uart_init();

	/* Just light voice LED */
	*(volatile u8 *) 0x01000000 = 0x20;

	/* Say hello */
	uart_puts("\r\n!LDR " VERSION " started.\r\n");

	/* Light advert LED */
	*(volatile u8 *) 0x01000000 = 0x2;

	delay_init();

	uart_puts("Looking for NAND.\r\n");

	/* Look for NAND */
	if (nand_init()) {
		nand_boot();
	}

	/* Failure */
	uart_puts("Failed to find/boot from NAND. Twiddling my thumbs.\r\n");

	/* Hard loop */
	for (;;)
		;
}
